summaryrefslogtreecommitdiffstats
path: root/binutils-2.25/gold/testsuite/tls_pie_test.sh
diff options
context:
space:
mode:
Diffstat (limited to 'binutils-2.25/gold/testsuite/tls_pie_test.sh')
-rwxr-xr-xbinutils-2.25/gold/testsuite/tls_pie_test.sh58
1 files changed, 58 insertions, 0 deletions
diff --git a/binutils-2.25/gold/testsuite/tls_pie_test.sh b/binutils-2.25/gold/testsuite/tls_pie_test.sh
new file mode 100755
index 00000000..009154fd
--- /dev/null
+++ b/binutils-2.25/gold/testsuite/tls_pie_test.sh
@@ -0,0 +1,58 @@
+#!/bin/sh
+
+# tls_pie_test.sh -- a test case for TLS symbols in PIE executables.
+
+# Copyright (C) 2015 Free Software Foundation, Inc.
+# Written by Cary Coutant <ccoutant@gmail.com>.
+
+# This file is part of gold.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
+# MA 02110-1301, USA.
+
+# This file goes with tls_pie_test, a program compiled and linked
+# with -fpie -pie. Since TLS offsets are known at link time, even
+# in a PIE executable, we want to make sure that there are no
+# dynamic relocations for the TLS symbols.
+
+check()
+{
+ if ! grep -q "$2" "$1"
+ then
+ echo "Did not find expected output in $1:"
+ echo " $2"
+ echo ""
+ echo "Actual output below:"
+ cat "$1"
+ exit 1
+ fi
+}
+
+check_missing()
+{
+ if grep -q "$2" "$1"
+ then
+ echo "Found unexpected output in $1:"
+ echo " $2"
+ echo ""
+ echo "Actual output below:"
+ cat "$1"
+ exit 1
+ fi
+}
+
+check_missing tls_pie_test.stdout "o1 + 0"
+check_missing tls_pie_test.stdout "o2 + 0"
+check_missing tls_pie_test.stdout "o3 + 0"